"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setAuthority = setAuthority;
exports.authorityDispatch = authorityDispatch;
exports.checkAuthority = checkAuthority;

var _reactRouterRedux = require("react-router-redux");

var _bizTypes = require("../constants/bizTypes");

var _confClassStore = _interopRequireDefault(require("../paramsStore/confClassStore"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function setAuthority(state) {
  return {
    type: _bizTypes.CHECK_AUTHORITY,
    visible: state
  };
}

function authorityDispatch(dispatch, statue, updateStatus) {
  if (statue) {
    if (updateStatus) {
      updateStatus(false);
    }

    dispatch(setAuthority(true));
  } else {
    dispatch(setAuthority(statue));
  }
}

function checkAuthority(updateStatus, fulfilled) {
  return function (dispatch) {
    var AuthorityInterceptor = (0, _confClassStore["default"])('AuthorityInterceptor');

    var authority = function authority(statue, resolve) {
      authorityDispatch(dispatch, statue, updateStatus);
      resolve(statue);
    };

    var redirect = function redirect(loaction) {
      dispatch((0, _reactRouterRedux.replace)(loaction));
    };

    new Promise(function (resolve) {
      AuthorityInterceptor.checkAuthority(function (statue) {
        return authority(statue, resolve);
      }, redirect);
    }).then(fulfilled);
  };
}