"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactRedux = require("react-redux");

var _redux = require("redux");

var _kitAction = require("../../actions/kitAction.js");

require("./tabbar.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var Tabbar = function Tabbar(props) {
  var link = function link(e, actions, location, routing) {
    e.stopPropagation();

    if (!routing.locationBeforeTransitions || routing.locationBeforeTransitions.pathname !== location.pathname) {
      actions.linkTo(location);
    }
  };

  var decrementAndRedirect = function decrementAndRedirect(e, actions, location) {
    e.stopPropagation();
    actions.tabBarDecrementAndRedirect(location);
  };

  var tabBarLocations = props.tabBarLocations,
      actions = props.actions,
      routing = props.routing;

  var loopTabBars = function loopTabBars(data) {
    return data.map(function (location, i) {
      var active = 'tabbar-normal';

      if (location.state && location.state.mark) {
        if (routing.locationBeforeTransitions && routing.locationBeforeTransitions.state && routing.locationBeforeTransitions.state.mark && routing.locationBeforeTransitions.state.mark === location.state.mark) {
          active = 'tabbar-active';
        }

        if (routing.locationBeforeTransitions && routing.locationBeforeTransitions.pathname === location.pathname && location.state.mark) {
          active = 'tabbar-active';
        }
      }

      if (i === 0) {
        return _react["default"].createElement("span", {
          onClick: function onClick(e) {
            link(e, actions, location, routing);
          },
          className: "tabbar-cell ".concat(active),
          key: location.state.mark
        }, _react["default"].createElement("em", {
          className: "fa fa-file-o",
          "aria-hidden": "true"
        }), location.state.mark);
      } else {
        return _react["default"].createElement("span", {
          onClick: function onClick(e) {
            link(e, actions, location, routing);
          },
          className: "tabbar-cell ".concat(active),
          key: location.state.mark
        }, _react["default"].createElement("em", {
          className: "fa fa-file-o",
          "aria-hidden": "true"
        }), location.state.mark, _react["default"].createElement("i", {
          className: "fa fa-close",
          onClick: function onClick(e) {
            decrementAndRedirect(e, actions, location);
          }
        }));
      }
    });
  };

  return _react["default"].createElement("div", {
    className: "tabBarLocations"
  }, loopTabBars(tabBarLocations), _react["default"].createElement("p", {
    className: "separate-line"
  }));
};

function mapState(state) {
  return {
    tabBarLocations: state.tabBarLocations,
    routing: state.routing
  };
}

function mapDispatch(dispatch) {
  return {
    actions: (0, _redux.bindActionCreators)({
      tabBarDecrementAndRedirect: _kitAction.tabBarDecrementAndRedirect,
      linkTo: _kitAction.linkTo
    }, dispatch)
  };
}

var _default = (0, _reactRedux.connect)(mapState, mapDispatch)(Tabbar);

exports["default"] = _default;