"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.decorateArmour = exports.readonly = exports.RootRoute = exports.BaseComponent = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactRedux = require("react-redux");

var _redux = require("redux");

var _bizAction = require("../actions/bizAction");

var _tools = require("../util/tools");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var BaseComponent = function BaseComponent(Comp, callBack) {
  var WithSubscription = function (_Component) {
    _inherits(WithSubscription, _Component);

    function WithSubscription() {
      _classCallCheck(this, WithSubscription);

      return _possibleConstructorReturn(this, _getPrototypeOf(WithSubscription).apply(this, arguments));
    }

    _createClass(WithSubscription, [{
      key: "componentDidMount",
      value: function componentDidMount() {
        callBack(this.props.location);
      }
    }, {
      key: "render",
      value: function render() {
        var props = _extends({}, this.props);

        return _react["default"].createElement("div", null, _react["default"].createElement(Comp, props));
      }
    }]);

    return WithSubscription;
  }(_react.Component);

  WithSubscription.displayName = "BaseComponentConnect(".concat((0, _tools.getDisplayName)(Comp), ")");
  return WithSubscription;
};

exports.BaseComponent = BaseComponent;

var RootRoute = function RootRoute(Target) {
  var WithSubscription = function WithSubscription(props) {
    var children = props.children,
        authorityStatus = props.authorityStatus,
        dispatch = props.dispatch,
        others = _objectWithoutProperties(props, ["children", "authorityStatus", "dispatch"]);

    var actions = (0, _redux.bindActionCreators)({
      checkAuthority: _bizAction.checkAuthority
    }, dispatch);
    return _react["default"].createElement("div", null, authorityStatus ? _react["default"].createElement("div", null, _react["default"].createElement(Target, _extends({}, others, actions)), _react["default"].createElement("div", {
      className: "".concat((0, _tools.getDisplayName)(Target), "-childRoutes")
    }, children)) : '');
  };

  WithSubscription.displayName = "RootRouteConnect(".concat((0, _tools.getDisplayName)(Target), ")");

  function mapState(state) {
    return {
      authorityStatus: state.authorityStatus
    };
  }

  return (0, _reactRedux.connect)(mapState)(WithSubscription);
};

exports.RootRoute = RootRoute;

var readonly = function readonly(target, name, descriptor) {
  descriptor.writable = false;
  return descriptor;
};

exports.readonly = readonly;

var decorateArmour = function decorateArmour(target, key, descriptor) {
  var method = descriptor.value;
  var moreDef = 100;
  var ret;

  descriptor.value = function () {
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    args[0] += moreDef;
    ret = method.apply(target, args);
    return ret;
  };

  return descriptor;
};

exports.decorateArmour = decorateArmour;