"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BaseParentRoute = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactRedux = require("react-redux");

var _redux = require("redux");

var _kitAction = require("../actions/kitAction.js");

var _tools = require("../util/tools");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var BaseParentRoute = function BaseParentRoute(Target) {
  var WithSubscription = function (_Component) {
    _inherits(WithSubscription, _Component);

    function WithSubscription(props) {
      var _this;

      _classCallCheck(this, WithSubscription);

      _this = _possibleConstructorReturn(this, _getPrototypeOf(WithSubscription).call(this, props));
      _this.state = {
        bridge: null
      };
      _this.bridge = _this.bridge.bind(_assertThisInitialized(_this));
      return _this;
    }

    _createClass(WithSubscription, [{
      key: "bridge",
      value: function bridge() {
        var _this2 = this;

        var info = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
        var action = arguments.length > 1 ? arguments[1] : undefined;
        this.setState({
          bridge: info
        });
        setTimeout(function () {
          _this2.setState({
            bridge: null
          });

          if (action) {
            action();
          }
        });
      }
    }, {
      key: "render",
      value: function render() {
        var _this3 = this;

        var _this$props = this.props,
            children = _this$props.children,
            parentRouteCompStatus = _this$props.parentRouteCompStatus,
            actions = _this$props.actions,
            props = _objectWithoutProperties(_this$props, ["children", "parentRouteCompStatus", "actions"]);

        var childrenO = _react["default"].Children.map(children, function (o, i) {
          return _react["default"].cloneElement(o, {
            bridge: _this3.bridge,
            key: i
          });
        });

        return _react["default"].createElement("div", null, _react["default"].createElement("div", {
          style: {
            display: props.route.path === props.location.pathname ? 'block' : parentRouteCompStatus ? 'block' : 'none'
          }
        }, _react["default"].createElement(Target, _extends({}, props, {
          bridge: this.state.bridge
        }))), _react["default"].createElement("div", {
          className: "".concat((0, _tools.getDisplayName)(Target), "-childRoutes")
        }, childrenO));
      }
    }]);

    return WithSubscription;
  }(_react.Component);

  WithSubscription.displayName = "BaseParentRouteConnect(".concat((0, _tools.getDisplayName)(Target), ")");

  function mapState(state) {
    return {
      parentRouteCompStatus: state.parentRouteCompStatus
    };
  }

  function mapDispatch(dispatch) {
    return {
      actions: (0, _redux.bindActionCreators)({
        parentRouteCompVisible: _kitAction.parentRouteCompVisible
      }, dispatch)
    };
  }

  return (0, _reactRedux.connect)(mapState, mapDispatch)(WithSubscription);
};

exports.BaseParentRoute = BaseParentRoute;