"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = ModalSelecter;

var _react = _interopRequireWildcard(require("react"));

var _reactRedux = require("react-redux");

var _redux = require("redux");

var _tools = require("../util/tools");

var _modelStore = _interopRequireDefault(require("../paramsStore/modelStore"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { keys.push.apply(keys, Object.getOwnPropertySymbols(object)); } if (enumerableOnly) keys = keys.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function packageActions(actions) {
  var newActions = {};

  for (var key in actions) {
    if (actions.hasOwnProperty(key)) {
      (function () {
        var action = actions[key];

        newActions[key] = function (params) {
          return function (dispatch, getStates) {
            return Promise.resolve(action(params, dispatch, getStates()));
          };
        };
      })();
    }
  }

  return newActions;
}

function generate(bo, model, dispatch, target) {
  var actionCreators = model.autowrite;
  var isCache = model.cache;
  var newO = {};

  var _loop = function _loop(key) {
    if (bo.hasOwnProperty(key)) {
      var newKey = "_".concat(key);
      var connectCount = newKey;
      newO[newKey] = bo[key];
      Object.defineProperty(newO, key, {
        get: function get() {
          if (isCache) {
            if ((0, _tools.isEmpty)(this[newKey]) && target["_".concat(model.namespace, "permission")][connectCount] && actionCreators[key] && model[connectCount] < model.maxConnect) {
                actionCreators[key]({}, dispatch).then(function () {
                  target["_".concat(model.namespace, "permission")][connectCount] = false;
                  model[connectCount] = 0;
                });
                model[connectCount]++;
              }
          } else if (target["_".concat(model.namespace, "permission")][connectCount] && actionCreators[key] && target["_".concat(model.namespace, "connectCount")][connectCount] < model.maxConnect) {
            actionCreators[key]({}, dispatch).then(function () {
              target["_".concat(model.namespace, "connectCount")][connectCount] = 0;
              target["_".concat(model.namespace, "permission")][connectCount] = false;
            });
            target["_".concat(model.namespace, "connectCount")][connectCount]++;
          }

          return this[newKey];
        },
        set: function set(value) {
          this[newKey] = value;
        }
      });
    }
  };

  for (var key in bo) {
    _loop(key);
  }

  return newO;
}

function matchModel(models, matcheName) {
  for (var i = 0; i < models.length; i++) {
    var mod = models[i];

    if (mod.namespace === matcheName) {
      return mod;
    }
  }
}

function ModalSelecter() {
  var args = [].slice.call(arguments);
  var selects = [];
  var actions = [];
  var firstParam = args[0];

  if (_typeof(firstParam) === 'object' && !isNaN(firstParam.length)) {
    selects = firstParam;
    actions = args[1] ? args[1] : [];
  } else if (_typeof(firstParam) === 'object') {
    actions = firstParam;
  }

  return function (Target) {
    var WithSubscription = function (_Component) {
      _inherits(WithSubscription, _Component);

      function WithSubscription(props) {
        var _this;

        _classCallCheck(this, WithSubscription);

        _this = _possibleConstructorReturn(this, _getPrototypeOf(WithSubscription).call(this, props));
        var dispatch = _this.props.dispatch;
        var ownerProps = {};

        if (selects && selects.length) {
          var models = (0, _modelStore["default"])();
          selects.forEach(function (slt) {
            var model = matchModel(models, slt);

            if (model.cache || !(0, _tools.isEmpty)(model.autowrite)) {
              var sts = model.state;
              var cco = {};
              var cpo = {};

              for (var k in sts) {
                if (sts.hasOwnProperty(k)) {
                  cco["_".concat(k)] = 0;
                  cpo["_".concat(k)] = true;
                  _this["_".concat(model.namespace, "connectCount")] = cco;
                  _this["_".concat(model.namespace, "permission")] = cpo;
                }
              }

              ownerProps[model.namespace] = generate(props[model.namespace], model, dispatch, _assertThisInitialized(_this));
            } else {
              ownerProps[model.namespace] = model;
            }
          }, _assertThisInitialized(_this));
        }

        _this.ownerProps = ownerProps;
        return _this;
      }

      _createClass(WithSubscription, [{
        key: "render",
        value: function render() {
          var _this2 = this;

          var props = _extends({}, this.props);

          selects.forEach(function (slt) {
            var model = props[slt];

            for (var key in model) {
              if (model.hasOwnProperty(key)) {
                _this2.ownerProps[slt][key] = model[key];
              }
            }
          }, this);

          var _this$ownerProps = this.ownerProps,
              dispatch = _this$ownerProps.dispatch,
              newProps = _objectWithoutProperties(_this$ownerProps, ["dispatch"]);

          return _react["default"].createElement("div", null, _react["default"].createElement("div", null, _react["default"].createElement(Target, _extends({}, props, newProps))));
        }
      }]);

      return WithSubscription;
    }(_react.Component);

    WithSubscription.displayName = "ModalSelecterConnect(".concat((0, _tools.getDisplayName)(Target), ")");

    function mapState(state) {
      var states = {};
      selects.forEach(function (stateName) {
        states[stateName] = state[stateName];
      }, this);
      return _objectSpread({}, states);
    }

    var newActions = packageActions(actions);

    function mapDispatch(dispatch) {
      return {
        actions: (0, _redux.bindActionCreators)(_objectSpread({}, newActions), dispatch),
        dispatch: dispatch
      };
    }

    return (0, _reactRedux.connect)(mapState, mapDispatch)(WithSubscription);
  };
}