"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "BaseActions", {
  enumerable: true,
  get: function get() {
    return _enhance["default"];
  }
});
Object.defineProperty(exports, "Tabbar", {
  enumerable: true,
  get: function get() {
    return _enhance.Tabbar;
  }
});
Object.defineProperty(exports, "Notification", {
  enumerable: true,
  get: function get() {
    return _enhance.Notification;
  }
});
Object.defineProperty(exports, "publicStore", {
  enumerable: true,
  get: function get() {
    return _publicStore["default"];
  }
});
Object.defineProperty(exports, "Selecter", {
  enumerable: true,
  get: function get() {
    return _connect.ModalSelecterConnect;
  }
});
Object.defineProperty(exports, "RootRouteConnect", {
  enumerable: true,
  get: function get() {
    return _BaseComponent.RootRoute;
  }
});
Object.defineProperty(exports, "combinModals", {
  enumerable: true,
  get: function get() {
    return _tools.combinArray;
  }
});
Object.defineProperty(exports, "AuthorityInterceptor", {
  enumerable: true,
  get: function get() {
    return _AuthorityInterceptor.AuthorityInterceptor;
  }
});
Object.defineProperty(exports, "Configuration", {
  enumerable: true,
  get: function get() {
    return _Configuration.Configuration;
  }
});
exports["default"] = void 0;

var _confStore = _interopRequireDefault(require("./paramsStore/confStore"));

var _modelStore = _interopRequireDefault(require("./paramsStore/modelStore"));

var _hostSetting = _interopRequireDefault(require("./hostSetting"));

var _renderApp = _interopRequireDefault(require("./renderApp"));

var _enhance = _interopRequireWildcard(require("./enhance"));

var _context = _interopRequireDefault(require("./context"));

var _publicStore = _interopRequireDefault(require("./paramsStore/publicStore"));

var _connect = require("./connect");

var _BaseComponent = require("./connect/BaseComponent");

var _tools = require("./util/tools.js");

var _AuthorityInterceptor = require("./configuration/AuthorityInterceptor");

var _Configuration = require("./annotation/Configuration");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

(0, _context["default"])();

function createApp() {
  return {
    config: function config() {},
    router: function router(conf) {
      (0, _confStore["default"])(conf);
    },
    model: function model(_model) {
      (0, _modelStore["default"])(_model);
    },
    setHost: function setHost(conf) {
      (0, _hostSetting["default"])(conf);
    },
    run: function run() {
      (0, _renderApp["default"])();
    }
  };
}

var _default = createApp;
exports["default"] = _default;