"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = notiExtension;

function notiExtension() {
  var center = {};
  var extension = {
    registObserver: function registObserver(obName, func) {
      center[obName] = func;
      return center;
    },
    getCenter: function getCenter() {
      return center;
    },
    postNoti: function postNoti(obName, obj) {
      if (!center[obName]) {
        if (process.env.NODE_ENV !== 'production') {
          console.warn("The observer '".concat(obName, "' is not found. You may have removed the observer"));
        }

        return false;
      }

      center[obName](obj);
    },
    removeOb: function removeOb(obName) {
      delete center[obName];
    }
  };
  return extension;
}