"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _tools = require("../util/tools");

function modelStoreCreate() {
  var models = [];
  return function (mods) {
    if (!mods) return models;
    mods.forEach(function (model) {
      var newModel = (0, _tools.objDeepCopy)(model);
      var connectCount = 0;
      var sts = model.state;

      for (var k in sts) {
        if (sts.hasOwnProperty(k)) {
          var newKey = "_".concat(k);
          newModel[newKey] = connectCount;
        }
      }

      newModel.maxConnect = 1;
      newModel.reducers = {};
      var newReducers = newModel.reducers;
      models.forEach(function (m, i) {
        if (newModel.namespace === m.namespace) {
          model.splice(i, 1);
        }
      });
      models.push(newModel);
      var rdus = model.reducers;

      for (var _k in rdus) {
        if (rdus.hasOwnProperty(_k)) {
          newReducers["".concat(model.namespace, "/").concat(_k)] = rdus[_k];
        }
      }
    });
  };
}

var modelStore = modelStoreCreate();
var _default = modelStore;
exports["default"] = _default;