"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.parentRouteCompVisible = exports["default"] = void 0;

var _kitTypes = require("../constants/kitTypes");

var _modules = _interopRequireDefault(require("../router/modules"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var initializationLocations = _modules["default"].initializationTabs;

var _default = function _default() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : initializationLocations ? initializationLocations.concat() : [];
  var action = arguments.length > 1 ? arguments[1] : undefined;

  switch (action.type) {
    case _kitTypes.TABBAR_INCREMENT:
      {
        if (!action.currentLocation.state || !action.currentLocation.state.mark) {
          return state.concat();
        }

        for (var i = 0; i < state.length; i++) {
          var location = state[i];

          if (location.pathname === action.currentLocation.pathname) {
            state[i] = action.currentLocation;
            return state.concat();
          }
        }

        state.push(action.currentLocation);
        return state.concat();
      }

    case _kitTypes.TABBAR_DECREMENT:
      {
        for (var _i = 0; _i < state.length; _i++) {
          var _location = state[_i];

          if (_location.pathname === action.currentLocation.pathname) {
            state.splice(_i, 1);
            return state.concat();
          }
        }

        return state.concat();
      }

    default:
      return state;
  }
};

exports["default"] = _default;

var parentRouteCompVisible = function parentRouteCompVisible() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
  var action = arguments.length > 1 ? arguments[1] : undefined;

  switch (action.type) {
    case _kitTypes.PARENT_ROUTE_COMP_VIS:
      return action.visible;

    default:
      return state;
  }
};

exports.parentRouteCompVisible = parentRouteCompVisible;