"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = modelReducers;

var _modelStore = _interopRequireDefault(require("../paramsStore/modelStore"));

var _kitTypes = require("../constants/kitTypes");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function modelReducers() {
  var reducers = {};
  (0, _modelStore["default"])().forEach(function (model) {
    reducers[model.namespace] = function () {
      var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : model.state;
      var action = arguments.length > 1 ? arguments[1] : undefined;

      if (model.reducers[action.type]) {
        return model.reducers[action.type](state, action);
      }

      switch (action.type) {
        case _kitTypes.STATE_ROLL_BACK:
          if (action.namespace === model.namespace) {
            return model.state;
          }

          break;

        default:
          return state;
      }
    };
  });
  return reducers;
}