"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = renderApp;

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _reactRouter = require("react-router");

var _reactRouterRedux = require("react-router-redux");

var _kitAction = require("./actions/kitAction");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function renderApp() {
  var Root = require('./containers/Root');

  var configureStore = require('./store/configureStore');

  var store = configureStore();
  var history = (0, _reactRouterRedux.syncHistoryWithStore)(_reactRouter.browserHistory, store);
  history.listen(function (location) {
    if (location.state && location.state.mark) {
      store.dispatch((0, _kitAction.tabBarIncrement)(location));
    }

    document.body.scrollTop = 0;
  });

  _reactDom["default"].render(_react["default"].createElement(Root, {
    store: store,
    history: history
  }), document.getElementById('root'));
}