"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactRouter = require("react-router");

var _reactRedux = require("react-redux");

var _connect = require("../connect");

var _kitAction = require("../actions/kitAction");

var _bizAction = require("../actions/bizAction");

var _modules = _interopRequireWildcard(require("./modules"));

var _tools = require("../util/tools");

var _confClassStore = _interopRequireDefault(require("../paramsStore/confClassStore"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var isFsChk = true;
var AuthorityInterceptor = (0, _confClassStore["default"])('AuthorityInterceptor');

function checkAuthorityBean(currentLocation, route, dispatch) {
  if (localStorage.fromLogin === 'true') {
    dispatch((0, _bizAction.setAuthority)(true));
  } else if (isFsChk) {
    if (route.state && route.state.checkAuthority === false) {
      AuthorityInterceptor.preHandle(currentLocation, function (location) {
        return dispatch((0, _kitAction.redirect)(location));
      }, function (statue) {
        return dispatch((0, _bizAction.setAuthority)(statue));
      }, true);
    } else {
      dispatch((0, _bizAction.checkAuthority)(function (updateStatus) {
        isFsChk = updateStatus;
      }, function () {
        AuthorityInterceptor.preHandle(currentLocation, function (location) {
          return dispatch((0, _kitAction.redirect)(location));
        }, function (statue) {
          return dispatch((0, _bizAction.setAuthority)(statue));
        }, true);
      }));
    }
  } else {
    dispatch((0, _bizAction.setAuthority)(true));
  }
}

function autowiredParentRoute(Comp, route) {
  var name = (0, _tools.getDisplayName)(Comp);

  if (name.indexOf('RootRouteConnect') < 0 && route.childRoutes) {
    return (0, _connect.BaseParentRouteConnect)(Comp);
  }

  return Comp;
}

var transformConfig = function transformConfig(routes, dispatch) {
  var deepLoop = function deepLoop(rts) {
    rts.forEach(function (route) {
      if (route.component) {
        var Comp = _modules.modules[route.compMatch];

        if (process.env.NODE_ENV !== 'production' && !Comp) {
          throw new Error("\u672A\u626B\u63CF\u5230'".concat(route.compMatch, "'\u8DEF\u5F84\u4E0B\u7684\u7684\u7EC4\u4EF6. \u8BF7\u68C0\u67E5\u8DEF\u7531\u914D\u7F6E\u6587\u4EF6\u662F\u5426\u914D\u7F6E\u6B63\u786E"));
        }

        Comp = (0, _connect.BaseComponentConnect)(Comp, function (location) {
          return checkAuthorityBean(location, route, dispatch);
        });
        Comp = autowiredParentRoute(Comp, route);

        route.component = function (props) {
          return _react["default"].createElement(Comp, props);
        };

        if (route.indexRoute) {
          route.indexRoute.onEnter = function (nextState, replace) {
            return replace({
              pathname: route.indexRoute.redirect,
              state: route.indexRoute.state
            });
          };
        } else {
          route.onEnter = function (nextState) {
            if (!isFsChk) {
              AuthorityInterceptor.preHandle(nextState.location, function (location) {
                return dispatch((0, _kitAction.redirect)(location));
              }, function (statue) {
                return dispatch((0, _bizAction.setAuthority)(statue));
              }, false);
            }

            if (route.childRoutes) {
              if (route.path === nextState.location.pathname) {
                dispatch((0, _kitAction.parentRouteCompVisible)(false));
              } else {
                dispatch((0, _kitAction.parentRouteCompVisible)(true));
              }
            } else {
              dispatch((0, _kitAction.parentRouteCompVisible)(false));
            }

            if (nextState.location.state && nextState.location.state.mark) {
              if (nextState.location.pathname === route.path) {
                dispatch((0, _kitAction.tabBarIncrement)(nextState.location));
              } else {
                dispatch((0, _kitAction.tabBarIncrement)({
                  pathname: route.path,
                  state: route.state
                }));
              }
            } else if (route.state) {
              if (nextState.location.pathname === route.path) {
                if (nextState.location.state) {
                  if (route.state) {
                    nextState.location.state.mark = route.state.mark;
                  }
                } else if (route.state) {
                  nextState.location.state = {
                    mark: route.state.mark
                  };
                }

                dispatch((0, _kitAction.tabBarIncrement)(nextState.location));
              } else {
                dispatch((0, _kitAction.tabBarIncrement)({
                  pathname: route.path,
                  state: route.state
                }));
              }
            }
          };
        }
      }

      if (route.childRoutes) {
        deepLoop(route.childRoutes, dispatch);
      }
    });
  };

  deepLoop(routes);
  return routes;
};

var RouterTree = function (_Component) {
  _inherits(RouterTree, _Component);

  function RouterTree() {
    _classCallCheck(this, RouterTree);

    return _possibleConstructorReturn(this, _getPrototypeOf(RouterTree).apply(this, arguments));
  }

  _createClass(RouterTree, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          history = _this$props.history,
          dispatch = _this$props.dispatch;
      return _react["default"].createElement(_reactRouter.Router, {
        routes: transformConfig(_modules["default"].routes, dispatch),
        history: history
      });
    }
  }]);

  return RouterTree;
}(_react.Component);

var _default = (0, _reactRedux.connect)()(RouterTree);

exports["default"] = _default;