"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = configureStore;

var _redux = require("redux");

var _reactRouterRedux = require("react-router-redux");

var _reactRouter = require("react-router");

var _reduxThunk = _interopRequireDefault(require("redux-thunk"));

var _reducers = _interopRequireDefault(require("../reducers"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var middleware = (0, _reactRouterRedux.routerMiddleware)(_reactRouter.browserHistory);
var enhancer = (0, _redux.compose)((0, _redux.applyMiddleware)(_reduxThunk["default"], middleware));

function configureStore(initialState) {
  var store = (0, _redux.createStore)((0, _reducers["default"])(), initialState, enhancer);

  if (module.hot) {
    module.hot.accept('../reducers', function () {
      return store.replaceReducer(require('../reducers')["default"]);
    });
  }

  return store;
}