"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = Ajax;
exports.AjaxNor = void 0;

var _antd = require("antd");

var flag = true;

function Ajax(option, response, _error) {
  $.ajax({
    url: option.url,
    method: option.method || 'GET',
    data: option.data || {},
    dataType: 'json',
    beforeSend: function beforeSend(req) {
      req.setRequestHeader('token', localStorage.token);
    },
    contentType: option.contentType || 'application/json',
    success: function success(data) {
      if (data.code === '401') {
        if (flag) {
          _antd.message.error(data.message, 2);

          flag = false;
        }

        setTimeout(function () {
          window.location.href = '/login';
        }, 1000);
      } else {
        response(data);
      }
    },
    error: function error(XMLHttpRequest) {
      if (XMLHttpRequest.status === 401) {
        if (XMLHttpRequest.responseJSON && XMLHttpRequest.responseJSON.code === '401') {
          _antd.message.error(XMLHttpRequest.responseJSON, 2);

          setTimeout(function () {
            window.location.href = '/login.html';
          }, 1000);
        }
      }

      if (_error) {
        _error(XMLHttpRequest.responseJSON);
      }
    }
  });
}

var AjaxNor = function AjaxNor(option, response, _error2) {
  $.ajax({
    url: option.url,
    method: option.method || 'GET',
    data: option.data || {},
    dataType: 'json',
    xhrFields: {
      withCredentials: true
    },
    crossDomain: true,
    beforeSend: function beforeSend(req) {
      req.setRequestHeader('token', localStorage.token);
    },
    contentType: option.contentType || 'application/json',
    success: function success(data) {
      response(data);
    },
    error: function error(XMLHttpRequest) {
      if (_error2) {
        _error2(XMLHttpRequest.responseJSON);
      }
    }
  });
};

exports.AjaxNor = AjaxNor;