"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _isomorphicFetch = _interopRequireDefault(require("isomorphic-fetch"));

var _tools = require("../util/tools");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { keys.push.apply(keys, Object.getOwnPropertySymbols(object)); } if (enumerableOnly) keys = keys.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function checkStatus(response) {
  if (response.status >= 200 && response.status < 300) {
    return response;
  }

  if (response.status === 401) {}

  console.error("\u8BF7\u6C42\u9519\u8BEF ".concat(response.status, ": ").concat(response.url), response.statusText);
  var error = new Error(response.statusText);
  error.response = response;
  throw error;
}

function send(url, options, autoTips) {
  var defaultOptions = {
    headers: {
      'X-Auth-Token': localStorage.token
    }
  };

  var newOptions = _objectSpread({}, defaultOptions, {}, options);

  if (newOptions.method === 'POST' || newOptions.method === 'PUT') {
    newOptions.headers = _objectSpread({
      Accept: 'application/json',
      'Content-Type': 'application/x-www-form-urlencoded; charset=utf-8'
    }, newOptions.headers);

    if (newOptions.body) {
      var data = new URLSearchParams();
      Object.keys(newOptions.body).map(function (v) {
        return data.set(v, newOptions.body[v]);
      });

      if (/multipart/.test(newOptions.headers['Content-Type'])) {
        newOptions.headers['Content-Type'] = 'multipart/form-data';
        data = new FormData();
        Object.keys(newOptions.body).map(function (v) {
          return data.append(v, newOptions.body[v]);
        });
      }

      newOptions.body = data;
    }
  }

  var newUrl = url;

  if (options && options.params) {
    newUrl = (0, _tools.urlAppendQuery)(url, options.params);
  }

  var checkBiz = function checkBiz(response) {
    return response.json().then(function (res) {
      if (autoTips) {
        if (!res.success) {
          notification.error({
            message: res.msg
          });
        } else if (res.msg) {
          notification.success({
            message: res.msg
          });
        }
      }

      return res;
    });
  };

  return (0, _isomorphicFetch["default"])(newUrl, newOptions).then(checkStatus).then(checkBiz)["catch"](function (error) {
    if (error.code) {
      notification.error({
        message: error.name,
        description: error.message
      });
    }

    if ('stack' in error && 'message' in error) {
      notification.error({
        message: "\u8BF7\u6C42\u9519\u8BEF: ".concat(url),
        description: error.message
      });
    }

    return error;
  });
}

var request = {
  GET: function GET(url, options, autoTips) {
    if (_typeof(options) !== 'object') {
      return send(url, {
        method: 'GET'
      }, options);
    }

    return send(url, _objectSpread({}, options, {
      method: 'GET'
    }), autoTips);
  },
  POST: function POST(url, options, autoTips) {
    if (_typeof(options) !== 'object') {
      return send(url, {
        method: 'POST'
      }, options);
    }

    return send(url, _objectSpread({}, options, {
      method: 'POST'
    }), autoTips);
  },
  PUT: function PUT(url, options, autoTips) {
    if (_typeof(options) !== 'object') {
      return send(url, {
        method: 'PUT'
      }, options);
    }

    return send(url, _objectSpread({}, options, {
      method: 'PUT'
    }), autoTips);
  },
  DELETE: function DELETE(url, options, autoTips) {
    if (_typeof(options) !== 'object') {
      return send(url, {
        method: 'DELETE'
      }, options);
    }

    return send(url, _objectSpread({}, options, {
      method: 'DELETE'
    }), autoTips);
  }
};
var _default = request;
exports["default"] = _default;