"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.splitGroup = splitGroup;
exports.findPath = findPath;
exports.getDisplayName = getDisplayName;
exports.urlAppendQuery = urlAppendQuery;
exports.objDeepCopy = objDeepCopy;
exports.combinArray = combinArray;
exports.isEmpty = isEmpty;
exports.removeDuplicate = removeDuplicate;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function splitGroup(array, key) {
  if (!array || array === undefined || array === '' || !array.length) {
    return false;
  }

  var arr = array.concat();
  var ret = [];
  loop(arr[0][key]);

  function loop(scaleplate) {
    var temp = [];

    for (var index = 0; index < arr.length; index++) {
      var element = arr[index];

      if (scaleplate === element[key]) {
        temp.push(element);
        arr.splice(index--, 1);
      }
    }

    ret.push(temp);

    if (arr.length) {
      loop(arr[0][key]);
    }
  }

  return ret;
}

function findPath(array, key, b, func) {
  var path = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : [];

  for (var i = 0; i < array.length; i++) {
    var element = array[i];

    if (element.children && element.children.length) {
      path.push(element[key]);

      if (element[key].toString() === b.toString()) {
        return func(path.concat());
      }

      findPath(element.children, b, func, path);
    } else if (element[key].toString() === b.toString()) {
      path.push(element[key]);
      return func(path.concat());
    }

    if (i === array.length - 1) {
      path.pop();
    }
  }
}

function getDisplayName(WrappedComponent) {
  return WrappedComponent.displayName || WrappedComponent.name || 'Component';
}

function urlAppendQuery(url, param) {
  if (!param) {
    return url;
  }

  var queryString = '';

  for (var key in param) {
    if (param.hasOwnProperty(key)) {
      queryString += "&".concat(key, "=").concat(param[key]);
    }
  }

  if (queryString) {
    return "".concat(url, "?").concat(queryString.substring(1));
  }

  return url;
}

function objDeepCopy(p) {
  var c = {};

  for (var k in p) {
    if (p.hasOwnProperty(k)) {
      c[k] = p[k];
    }
  }

  return c;
}

function combinArray() {
  var args = [].slice.call(arguments);
  var ret = [];
  return ret.concat.apply(ret, _toConsumableArray(args));
}

function isEmpty(obj) {
  if (obj) {
    if (_typeof(obj) === 'object' && !isNaN(obj.length)) {
      if (obj.length > 0) {
        return false;
      }
    } else if (_typeof(obj) === 'object') {
      for (var k in obj) {
        if (obj.hasOwnProperty(k)) {
          return false;
        }
      }
    }
  }

  return true;
}

function removeDuplicate(array, key) {
  if (key) {
    for (var i = 0; i < array.length; i++) {
      var pattern = array[i][key];

      for (var j = i + 1; j < array.length; j++) {
        var element = array[j];

        if (pattern === element[key]) {
          array.splice(j--, 1);
        }
      }
    }
  } else {
    for (var _i = 0; _i < array.length; _i++) {
      var _pattern = array[_i];

      for (var _j = _i + 1; _j < array.length; _j++) {
        var _element = array[_j];

        if (_pattern === _element) {
          array.splice(_j--, 1);
        }
      }
    }
  }

  return array;
}